diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/spectrum-analyzer.h ns-3.36/src/spectrum/model/spectrum-analyzer.h
--- ns-3.35/src/spectrum/model/spectrum-analyzer.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/spectrum-analyzer.h	2022-04-30 18:23:58.146735000 -0700
@@ -65,7 +65,7 @@
   Ptr<MobilityModel> GetMobility () const;
   Ptr<NetDevice> GetDevice () const;
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna () const;
+  Ptr<Object> GetAntenna () const;
   void StartRx (Ptr<SpectrumSignalParameters> params);
 
 
@@ -114,10 +114,12 @@
 
   /**
    * Adds a signal to the data collected.
+   * \param psd signal to add
    */
   void AddSignal (Ptr<const SpectrumValue> psd);
   /**
    * Removes a signal to the data collected.
+   * \param psd signal to subtract
    */
   void SubtractSignal  (Ptr<const SpectrumValue> psd);
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/spectrum-channel.cc ns-3.36/src/spectrum/model/spectrum-channel.cc
--- ns-3.35/src/spectrum/model/spectrum-channel.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/spectrum-channel.cc	2022-04-30 18:23:58.146735000 -0700
@@ -136,6 +136,18 @@
 }
 
 void
+SpectrumChannel::AddPhasedArraySpectrumPropagationLossModel (Ptr<PhasedArraySpectrumPropagationLossModel> loss)
+{
+  NS_LOG_FUNCTION (this << loss);
+  if (m_phasedArraySpectrumPropagationLoss)
+    {
+      loss->SetNext (m_phasedArraySpectrumPropagationLoss);
+    }
+  m_phasedArraySpectrumPropagationLoss = loss;
+}
+
+
+void
 SpectrumChannel::SetPropagationDelayModel (Ptr<PropagationDelayModel> delay)
 {
   NS_ASSERT (m_propagationDelay == 0);
@@ -149,6 +161,13 @@
   return m_spectrumPropagationLoss;
 }
 
+Ptr<PhasedArraySpectrumPropagationLossModel>
+SpectrumChannel::GetPhasedArraySpectrumPropagationLossModel (void)
+{
+  NS_LOG_FUNCTION (this);
+  return m_phasedArraySpectrumPropagationLoss;
+}
+
 Ptr<PropagationLossModel>
 SpectrumChannel::GetPropagationLossModel ()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/spectrum-channel.h ns-3.36/src/spectrum/model/spectrum-channel.h
--- ns-3.35/src/spectrum/model/spectrum-channel.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/spectrum-channel.h	2022-04-30 18:23:58.146735000 -0700
@@ -27,6 +27,7 @@
 #include <ns3/channel.h>
 #include <ns3/spectrum-signal-parameters.h>
 #include <ns3/spectrum-propagation-loss-model.h>
+#include <ns3/phased-array-spectrum-propagation-loss-model.h>
 #include <ns3/propagation-delay-model.h>
 #include <ns3/propagation-loss-model.h>
 #include <ns3/spectrum-phy.h>
@@ -84,6 +85,13 @@
   void AddSpectrumPropagationLossModel (Ptr<SpectrumPropagationLossModel> loss);
 
   /**
+   * Add the frequency-dependent propagation loss model
+   * that is compapatible with the phased antenna arrays at the TX and RX
+   * \param loss a pointer to the propagation loss model to be used.
+   */
+  void AddPhasedArraySpectrumPropagationLossModel (Ptr<PhasedArraySpectrumPropagationLossModel> loss);
+
+  /**
    * Set the propagation delay model to be used
    * \param delay Ptr to the propagation delay model to be used.
    */
@@ -96,6 +104,13 @@
   Ptr<SpectrumPropagationLossModel> GetSpectrumPropagationLossModel (void);
 
   /**
+   * Get the frequency-dependent propagation loss model that is
+   * compatible with the phased antenna arrays at TX and RX
+   * \returns a pointer to the propagation loss model.
+   */
+  Ptr<PhasedArraySpectrumPropagationLossModel> GetPhasedArraySpectrumPropagationLossModel (void);
+
+  /**
    * Get the propagation loss model.
    * \returns a pointer to the propagation loss model.
    */
@@ -109,6 +124,21 @@
   virtual void StartTx (Ptr<SpectrumSignalParameters> params) = 0;
 
   /**
+   * \brief Remove a SpectrumPhy from a channel
+   *
+   * This method is used to detach a SpectrumPhy instance from a
+   * SpectrumChannel instance, so that the SpectrumPhy does not receive
+   * packets sent on that channel.
+   *
+   * This method is to be implemented by all classes inheriting from
+   * SpectrumChannel.
+   *
+   * @param phy the SpectrumPhy instance to be removed from the channel as
+   * a receiver.
+   */
+  virtual void RemoveRx (Ptr<SpectrumPhy> phy) = 0;
+
+  /**
    * \brief Add a SpectrumPhy to a channel, so it can receive packets
    *
    * This method is used to attach a SpectrumPhy instance to a
@@ -198,6 +228,11 @@
    */
   Ptr<SpectrumPropagationLossModel> m_spectrumPropagationLoss;
 
+  /**
+   * Frequency-dependent propagation loss model to be used with this channel.
+   */
+  Ptr<PhasedArraySpectrumPropagationLossModel> m_phasedArraySpectrumPropagationLoss;
+
 
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/spectrum-model-300kHz-300GHz-log.cc ns-3.36/src/spectrum/model/spectrum-model-300kHz-300GHz-log.cc
--- ns-3.35/src/spectrum/model/spectrum-model-300kHz-300GHz-log.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/spectrum-model-300kHz-300GHz-log.cc	2022-04-30 18:23:58.146735000 -0700
@@ -24,10 +24,19 @@
 namespace ns3 {
 
 
+/**
+ * \ingroup spectrum
+ * Spectrum model logger for frequencies between 300 Khz 300 Ghz
+ */
 Ptr<SpectrumModel> SpectrumModel300Khz300GhzLog;
 
 
-
+/**
+ * \ingroup spectrum
+ * 
+ * Static initializer class for Spectrum model logger 
+ * for frequencies between 300 Khz 300 Ghz
+ */
 class static_SpectrumModel300Khz300GhzLog_initializer
 {
 public:
@@ -42,10 +51,12 @@
     SpectrumModel300Khz300GhzLog = Create<SpectrumModel> (freqs);
   }
 
-} static_SpectrumModel300Khz300GhzLog_initializer_instance;
-
-
-
+};
 
+/**
+ * \ingroup spectrum
+ * Static variable for analyzer initialization
+ */
+static_SpectrumModel300Khz300GhzLog_initializer g_static_SpectrumModel300Khz300GhzLog_initializer_instance;
 
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/spectrum-model.h ns-3.36/src/spectrum/model/spectrum-model.h
--- ns-3.35/src/spectrum/model/spectrum-model.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/spectrum-model.h	2022-04-30 18:23:58.146735000 -0700
@@ -28,7 +28,12 @@
 
 /**
  * \defgroup spectrum Spectrum Models
- *
+ */
+
+/**
+ * \ingroup spectrum
+ * \ingroup tests
+ * \defgroup spectrum-tests Spectrum Models tests
  */
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/spectrum-model-ism2400MHz-res1MHz.cc ns-3.36/src/spectrum/model/spectrum-model-ism2400MHz-res1MHz.cc
--- ns-3.35/src/spectrum/model/spectrum-model-ism2400MHz-res1MHz.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/spectrum-model-ism2400MHz-res1MHz.cc	2022-04-30 18:23:58.146735000 -0700
@@ -23,11 +23,20 @@
 
 namespace ns3 {
 
-
+/**
+ * \ingroup spectrum
+ * Spectrum model logger for frequencies in the 2.4 GHz ISM band
+ * with 1 MHz resolution.
+ */
 Ptr<SpectrumModel> SpectrumModelIsm2400MhzRes1Mhz;
 
 
-
+/**
+ * \ingroup spectrum
+ * 
+ * Static initializer class for Spectrum model logger for 
+ * frequencies in the 2.4 GHz ISM band with 1 MHz resolution.
+ */
 class static_SpectrumModelIsm2400MhzRes1Mhz_initializer
 {
 public:
@@ -44,10 +53,12 @@
     SpectrumModelIsm2400MhzRes1Mhz = Create<SpectrumModel> (freqs);
   }
 
-} static_SpectrumModelIsm2400MhzRes1Mhz_initializer_instance;
-
-
-
+};
 
+/**
+ * \ingroup spectrum
+ * Static variable for analyzer initialization
+ */
+static_SpectrumModelIsm2400MhzRes1Mhz_initializer g_static_SpectrumModelIsm2400MhzRes1Mhz_initializer_instance;
 
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/spectrum-phy.h ns-3.36/src/spectrum/model/spectrum-phy.h
--- ns-3.35/src/spectrum/model/spectrum-phy.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/spectrum-phy.h	2022-04-30 18:23:58.146735000 -0700
@@ -31,6 +31,7 @@
 class SpectrumChannel;
 class MobilityModel;
 class AntennaModel;
+class PhasedArrayModel;
 class SpectrumValue;
 class SpectrumModel;
 class NetDevice;
@@ -49,6 +50,10 @@
   SpectrumPhy ();
   virtual ~SpectrumPhy ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  SpectrumPhy (SpectrumPhy const &) = delete;
+  SpectrumPhy &operator= (SpectrumPhy const &) = delete;
+
   /**
    * \brief Get the type ID.
    * \return the object TypeId
@@ -99,11 +104,16 @@
   virtual Ptr<const SpectrumModel> GetRxSpectrumModel () const = 0;
 
   /**
-   * Get the AntennaModel used by the NetDevice for reception
+   * \brief Get the AntennaModel used by this SpectrumPhy instance for
+   * transmission and/or reception
+   *
+   * Note that in general and depending on each module design, there can be
+   * multiple SpectrumPhy instances per NetDevice.
    *
-   * @return a Ptr to the AntennaModel used by the NetDevice for reception
+   * @return a Ptr to the AntennaModel used by this SpectrumPhy instance for
+   * transmission and/or reception
    */
-  virtual Ptr<AntennaModel> GetRxAntenna () const = 0;
+  virtual Ptr<Object> GetAntenna () const = 0;
 
   /**
    * Notify the SpectrumPhy instance of an incoming signal
@@ -111,35 +121,7 @@
    * @param params the parameters of the signals being received
    */
   virtual void StartRx (Ptr<SpectrumSignalParameters> params) = 0;
-
-private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  SpectrumPhy (SpectrumPhy const &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  SpectrumPhy& operator= (SpectrumPhy const &);
 };
-
-
-
-
-
-
-
-
-
 } // namespace ns3
 
-
-
-
-
 #endif /* SPECTRUM_PHY_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/spectrum-signal-parameters.h ns-3.36/src/spectrum/model/spectrum-signal-parameters.h
--- ns-3.35/src/spectrum/model/spectrum-signal-parameters.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/spectrum-signal-parameters.h	2022-04-30 18:23:58.146735000 -0700
@@ -66,6 +66,7 @@
 
   /**
    * copy constructor
+   * \param p object to copy
    */
   SpectrumSignalParameters (const SpectrumSignalParameters& p);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/spectrum-value.h ns-3.36/src/spectrum/model/spectrum-value.h
--- ns-3.35/src/spectrum/model/spectrum-value.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/spectrum-value.h	2022-04-30 18:23:58.146735000 -0700
@@ -572,10 +572,12 @@
   void ChangeSign ();
   /**
    * Shift the values to the left
+   * \param n number of positions to shift
    */
   void ShiftLeft (int n);
   /**
    * Shift the values to the right
+   * \param n number of positions to shift
    */
   void ShiftRight (int n);
   /**
